Name:		photomatix
Version:	1.1
Release:	2%{?dist}
Summary:	Creates HDR images from multiple and single images

Group:		Applications/Multimedia
License:	Copyright (c) HDRsoft Ltd
URL:		http://hdrsoft.com
Source0:	photomatix.tar.gz

BuildRequires:	OpenEXR-devel libtiff-devel
%if 0%{?fedora}
AutoReqProv: no
Requires:	OpenEXR-libs, atk, atkmm, libtiff, glibc >= 2.1, cairo-gobject, cairo, cairomm, libgcc >= 4.5, gtk3, gdk-pixbuf2, gtkmm30, glib2 >= 2.0, glibmm24 >= 2.0, libgomp, libjpeg-turbo, lcms2, pango, pangomm, libsigc++20, libstdc++ >= 4.5, libtiff >= 3.0, tinyxml, zlib
#Requires:	libatkmm-1.6.so.1, libatk-1.0.so.0, libtiff.so.5, glibc >= 2.1, libcairo-gobject.so.2, libcairo.so.2, libcairomm-1.0.so.1, libgcc >= 4.5, libgtk-3.so.0, libgdk_pixbuf-2.0.so.0, libgtkmm-3.0.so.1, glib2 >= 2.0, glibmm24 >= 2.0, libgomp.so.1, libjpeg-turbo, liblcms2.so.2, libpango-1.0.so.0, libpangomm-1.4.so.1, libsigc-2.0.so.0, libstdc++ >= 4.5, libtinyxml.so.0, libz.so.1
#Requires:	libatkmm-1.6.so.1()(64bit), libatk-1.0.so.0()(64bit), glibc >= 2.1, libcairo-gobject.so.2()(64bit), libcairo.so.2()(64bit), libcairomm-1.0.so.1()(64bit), libgtk-3.so.0()(64bit), libgdk_pixbuf-2.0.so.0()(64bit), libgtkmm-3.0.so.1()(64bit), glib2 >= 2.0, glibmm24 >= 2.0, libgomp.so.1()(64bit), libjpeg-turbo, liblcms2.so.2()(64bit), libpango-1.0.so.0()(64bit), libpangomm-1.4.so.1()(64bit), libsigc-2.0.so.0()(64bit), libtinyxml.so.0()(64bit), libz.so.1()(64bit)
%endif

%description
Standalone program to create HDR photos and adjust them to the look you want, from natural to artistic. Includes advanced editing features and Plugin for Lightroom.

%prep
%setup -q


%build
#make %{?_smp_mflags}
make


%install
make install DESTDIR=%{buildroot}
(cd %{buildroot}/%{_libdir}; for i in *.so; do test -e $i.1 || ln -s $i $i.1; done)
glib-compile-schemas %{buildroot}/usr/share/glib-2.0/schemas 2>&1 | grep -v warning || true; test ${PIPESTATUS[0]} -eq 0



%files
%{_bindir}/photomatix
%{_bindir}/photomatix-bin
%{_libexecdir}/PhotomatixCL
%{_libexecdir}/PhotomatixCL-bin
%{_libdir}/*.so*
%{_datadir}/%{name}/BuiltinPresets
%{_datadir}/%{name}/*.dat
%{_datadir}/%{name}/*.glade
%{_datadir}/%{name}/*.png
%{_datadir}/%{name}/*.css
%{_datadir}/%{name}/DynamicText.resx
%{_datadir}/glib-2.0/schemas/apps.photomatix.gschema.xml
/usr/share/locale/*/LC_MESSAGES/photomatix.mo
%exclude %{_datadir}/glib-2.0/schemas/gschemas.compiled

%post
glib-compile-schemas /usr/share/glib-2.0/schemas 2>&1 | grep -v warning || true; test ${PIPESTATUS[0]} -eq 0

%postun
glib-compile-schemas /usr/share/glib-2.0/schemas 2>&1 | grep -v warning || true; test ${PIPESTATUS[0]} -eq 0

%changelog

