#ifndef BATCHSETTINGSWINDOW_H
#define BATCHSETTINGSWINDOW_H


#include <gtkmm.h>


#include "../PhotomatixControls/detailsenhancersettings.h"
#include "../PhotomatixControls/tonecompressorsettings.h"
#include "../PhotomatixControls/tonebalancersettings.h"
#include "../PhotomatixControls/contrastoptimizersettings.h"
#include "../PhotomatixControls/exposurefusionsettings.h"


namespace Photomatix
{
	class BatchSettingsWindow: public Gtk::Window
	{
	protected:
		/// Settings controls
		PhotomatixControls::DetailsEnhancerSettings* deSettingsControl;
		PhotomatixControls::ToneCompressorSettings* tcSettingsControl;
		PhotomatixControls::ToneBalancerSettings* tbSettingsControl;
		PhotomatixControls::ContrastOptimizerSettings* coSettingsControl;
		PhotomatixControls::ExposureFusionSettings* efSettingsControl;
		
		PhotomatixControls::ProcessingSettingsControl* settingsControl;
		
		Gtk::Button* btnOk;
		Gtk::Box* box;
		
		void OnBtnOkClicked();

	public:
		BatchSettingsWindow(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& gladeBuilder);
		virtual ~BatchSettingsWindow();
		
		void InitForm(int method);
		
		PhotomatixImaging::XmpSettings* GetCurrentSettings();
	};
}

#endif // DETAILSENHANCERSETTINGSWINDOW_H
