#include "presetthumbnail.h"
#include "../Photomatix32/Photomatix32.h"
#include "../Photomatix32/PhotomatixMetaLib.h"
#include "../Photomatix32/tmlib.h"
#include "../PhotomatixImaging/photoimage.h"
#include "../PhotomatixControls/displayableimagecontrol.h"
#include "../PhotomatixMisc/photomatixconstants.h"

#include <gtkmm/cssprovider.h>
#include <clocale>
#include <cstring>

#include "pangomm.h"


using namespace PhotomatixControls;
using namespace PhotomatixImaging;
using namespace std;


namespace Photomatix
{
	PresetThumbnail::PresetThumbnail():
		presetImage(nullptr)
	{
		this->set_orientation(Gtk::ORIENTATION_VERTICAL);
		this->set_homogeneous(false);
		
		this->presetName = new Gtk::Label("Test label", Gtk::ALIGN_CENTER);
		this->presetName->set_ellipsize(Pango::EllipsizeMode::ELLIPSIZE_MIDDLE);
		
		this->presetImage = new DisplayableImageControl();
		
		this->presetImage->set_size_request(100, 20);
		this->presetName->set_size_request(100, 20);
		
		this->pack_start(*this->presetImage, Gtk::PACK_SHRINK);//, true);
		this->pack_start(*this->presetName, Gtk::PACK_SHRINK);//, true);
		
		
		this->presetImage->signal_mouse_down.connect(sigc::mem_fun(*this, &PresetThumbnail::OnThumbnailClicked));
		
		//this->set_border_width(20);
		this->set_size_request(120, 110);
		//this->set_resizable(false);
	}

	PresetThumbnail::~PresetThumbnail()
	{

	}
	
	void PresetThumbnail::OnThumbnailClicked(GdkEventButton* evt)
	{
		this->signal_thumbnail_clicked.emit(this);
	}
	
	void PresetThumbnail::get_preferred_height_vfunc(int& minimum_height, int& natural_height) const
	{
		minimum_height = 80;
		natural_height = 80;
	}
	
	void PresetThumbnail::SetThumbnailImage(shared_ptr< PhotomatixImaging::PhotoImage > image)
	{
		this->presetImage->SetPhoto(image);
		
		int width = 120; int height = 120;
		this->presetImage->GetPhoto()->GetProportionalSize(120, 120, width, height);
		
		this->presetImage->SetZoomFactor((float)width / image->GetWidth());
		this->presetImage->set_size_request(width, height);
		this->presetImage->set_halign(Gtk::ALIGN_CENTER);
		
		Pango::FontDescription font("8");
		this->presetName->override_font(font);
		//this->presetName->set_
		
		this->set_size_request(120, height + 20);
	}
	
	void PresetThumbnail::SetSettings(const Preset& preset)
	{
		this->preset = preset;
		this->presetName->set_text(this->preset.GetDisplayName());
	}

	void PresetThumbnail::SetSelected(bool selected)
	{
		this->presetImage->SetBorder(selected);
	}
}
