#ifndef PROGRESSFORM_H
#define PROGRESSFORM_H


#include <memory>
#include <gtkmm.h>


namespace Photomatix
{
	class LinuxProgressNotifier;
	struct ProgressInfo;
	
	/** Progress form displaying a message and progress bar.
	 */
	class ProgressForm: public Gtk::Dialog
	{
	private:
		Gtk::Label* lblMessage;
		Gtk::ProgressBar* prgProgress;
		Gtk::Button* btnStop;
		
		std::shared_ptr <LinuxProgressNotifier> progressNotifier;
		
		void OnButtonStopClicked();
		void OnProgress();
		
	public:
		ProgressForm(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& builder);
		virtual ~ProgressForm();
		
		std::shared_ptr <LinuxProgressNotifier> GetProgressNotifier() {return this->progressNotifier;}
		
		/// Signal emitted when the ok button was clicked.
		sigc::signal<void> signal_stop_button_clicked;
	};
}


#endif // PROGRESSFORM_H
