#include "trialform.h"
#include "registerdialog.h"
#include "GladeUtils.h"
#include "../PhotomatixMisc/appproperties.h"
#include "../PhotomatixMisc/localtext.h"


using namespace PhotomatixMisc;


namespace Photomatix
{
	TrialForm::TrialForm(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& gladeBuilder):
		Gtk::Dialog::Dialog(cobject)
	{
		gladeBuilder->get_widget("btnRegister", this->btnRegister);
		gladeBuilder->get_widget("btnContinueTrial", this->btnContinueTrial);
		gladeBuilder->get_widget("btnOrderKey", this->btnOrderKey);
		
		this->btnRegister->signal_clicked().connect(sigc::mem_fun(*this, &TrialForm::OnRegisterButtonClicked));
		this->btnContinueTrial->signal_clicked().connect(sigc::mem_fun(*this, &TrialForm::OnContinueTrialButtonClicked));
		this->btnOrderKey->signal_clicked().connect(sigc::mem_fun(*this, &TrialForm::OnOrderKeyButtonClicked));
	}

	TrialForm::~TrialForm()
	{

	}
	
	void TrialForm::OnContinueTrialButtonClicked()
	{
		this->hide();
	}

	void TrialForm::OnOrderKeyButtonClicked()
	{
		GError *error = NULL;
		gtk_show_uri(gdk_screen_get_default(), LocalText::GetUrlOrderPage().c_str(), gtk_get_current_event_time(), &error);
		if(error) {
			Gtk::MessageDialog dialog(*this, "Error", false, Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK);
			dialog.set_secondary_text("There was a problem opening web page");
			dialog.run();
		}
	}

	void TrialForm::OnRegisterButtonClicked()
	{
		RegisterDialog* registerDialog;
		PhotomatixUtils::get_widget_derived("register-dialog", registerDialog);
		registerDialog->run();
		registerDialog->hide();
		if(AppProperties::IsRegistered())
			this->hide();
	}

}
