#ifndef _WINDOWSEMULATION_H
#define _WINDOWSEMULATION_H
#ifdef __cplusplus
extern "C" {
#endif
#include <limits.h>
#include <dlfcn.h>
#define _MAX_PATH PATH_MAX
#ifndef MAX_PATH
#define MAX_PATH PATH_MAX
#endif
#define __stdcall
#define _mkdir mkdir
#define _chdir chdir
#define _access access
#if !defined(max) && !defined(__cplusplus)
#define max(a,b) \
   ({ __typeof__ (a) _a = (a); \
       __typeof__ (b) _b = (b); \
     _a > _b ? _a : _b; })
#endif
#if !defined(min) && !defined(__cplusplus)
#define min(a,b) \
   ({ __typeof__ (a) _a = (a); \
       __typeof__ (b) _b = (b); \
     _a < _b ? _a : _b; })
#endif

#define CALLBACK
typedef unsigned char UCHAR;
typedef unsigned short USHORT;

// TODO: This is used for colour management - we should probably find a way of
// doing this under Linux.  For now we hide the data type.
typedef void *HDC;

typedef void *HINSTANCE;
HINSTANCE LoadLibrary(const char *libName);
void *GetProcAddress(HINSTANCE lib, const char *func);
void FreeLibrary(HINSTANCE lib);
int GetTempPath(int maxLen, char *str);
int GetTempFileName(const char *lpPathName, const char *lpPrefixString, 
		    int uUnique, char *lpTempFileName);

typedef int HKEY;
#define HKEY_CURRENT_USER 1
#if !defined( __cms_H) || !defined(__APPLE__)
// Horrible hack - MacOS LCMS defines DWORD itself
typedef unsigned long DWORD;
#endif
//int RegOpenKeyEx(HKEY key, string 

#ifdef __cplusplus
}
#endif
#endif
