#ifndef _TMLIB_H
#define _TMLIB_H
#ifdef __cplusplus
extern "C" {
#endif

//#define XMP_LEN  20        //121007: moved to metalib.h 
#define TM_INFO_LEN 13
//#define LUM_PARAM_MAX 10 //121126 moved to Photomatix.h
#define VAR_CLIP_ENHANCER (log(0.025)/log(0.3))  //3.064
#include <sys/types.h>
#include <stdio.h>
#include "Photomatix32.h"

#ifndef _WIN32
#define __stdcall
#endif

/*
typedef struct {
    int wImage;
	int hImage;
    int spp;
	int bpsIn;
	int bpsOut;
	int rowIn;
	int rowOut;
	int isBGR;
	int colorPlanes;
	int pluginPS;
} dim_param_struct;
*/

int mem4enhancer(int docType, dim_param_struct dimParam,  float *tmParam, size_t *lenInternal, size_t *totalMemNeeded); 
//int tm_dim (int iMax, int jMax, float *tmParam, int64_t *dims);


int  pm_tm_enhancer (int docType, dim_param_struct dimParam, optim_param_struct optimParam, float *tmParam, unsigned char *localAdjustmentMap, float *lumParam, float *expLUT, float *camCurve, ProgressCallback callback, char *pSource, char *tmWork);

int __stdcall mem4contrast_optimizer (int nbProc, dim_param_struct dimParam,  size_t *lenMemToPreallocate);
int __stdcall pm_tm_optimizer (dim_param_struct dimParam, optim_param_struct optimParam, ProgressCallback callback, float *tmParam, unsigned char *localAdjustmentMap, int isAlreadyMapped, char *tmWork, unsigned char *inImage, size_t lenPreallocatedMemory, unsigned char *outImage);
int mem4co1(int nbProc, dim_param_struct dimParam,  size_t *lenMemToPreallocate);
int pm_tm_co1		(dim_param_struct dimParam, optim_param_struct optimParam, ProgressCallback callback, float *tmParam, int isAlreadyMapped, char *tmWork, unsigned char *inImage, size_t lenPreallocatedMemory, unsigned char *outImage);

	
int __stdcall tm_simple (dim_param_struct dimParam, float *tmParam, unsigned char *localAdjustmentMap, float *lumParam, float *expLUT, optim_param_struct optimParam, unsigned char *inImage, unsigned char *outImage);
void __stdcall init_optim_param(optim_param_struct *optimParam);
void __stdcall init_dim_param(dim_param_struct *dimParam);					

int  __stdcall camcurve(int linear, int taille, float *courbe);

int  __stdcall decomp_rle(const char *filename, int *infos, unsigned char *decomp);

int __stdcall convert_to_rgbe (int bpsIn, const int iMax, const int jMax, const int spp, const int rowStride, int isBGR, float *courbe, unsigned char *pImage, unsigned char *rgbe);
int get_log_lum(int docType, int wImage, int hImage, int spp, int rowStride, float *lumParam, float *camCurve, float *inImage, float *outLogLum); 
			 
int __stdcall tmparam_default(int tmMethod, int docType, float *tmParam);

int tm310 (const int nivo, const int imW, const int imH, float *extended, float *pyram);
int tm321 (const int isLowpass, const int nivW, const int nivH, int positPyram, float *pyram, float *vectI);
int tm322 (const int nivW, const int nivH, float *vectI, float *moyenne, float *activity);
int tm323 (const int isLowpass, const int nivW, const int nivH, int positPyram, float alpha, float beta, float epsilon, float *activity, float *pyram);
int tm325 (const int iniv, const int nivoMax, const int nivW, const int nivH, float *vectI, float *moyArr, float *aggregate);
int tm326 (const int nivW, const int nivH, float alpha, float beta, float epsilon, float *activity);
int tm327 (const int isLowpass, const float gain_amount, const int nivW, const int nivH, int positPyram, float *gain, float *pyram);
int tm330 (const int nivo, const int imW, const int imH, const int lenPyram, float *pyram, float *low);


float adjust_percentile (float perc, size_t imageSize, const int histoLen, int *histo);


int __stdcall calc_tm1 (int docType, dim_param_struct dimParam, float *tmParam, int radTm2, float *lumParam, float *expLUT, float *camCurve, optim_param_struct optimParam, ProgressCallback callback, unsigned char *inImage, float *outImage);

int __stdcall calc_tm2old (dim_param_struct dimParam, int w1, int h1, size_t taillePyramide, size_t sizeInput, const int rangMaxInt, float *tmParam, optim_param_struct optimParam, FILE *ifpIn, ProgressCallback callback, float *tm2Buffer);

int __stdcall calc_tm2new2 (dim_param_struct dimParam, int nivo, float *tmParam, optim_param_struct optimParam, ProgressCallback callback, float *outImage);

int __stdcall pm_tm_balancer (dim_param_struct dimParam, optim_param_struct optimParam, int colorSpace, float *tmParam, unsigned char *localAdjustmentMap, char *memProcessingWork,  unsigned char *inImage, unsigned char *outImage);

int __stdcall extract_qv(int docType, int iMax, int jMax, int spp, int rowIn, int rowOut, int qvW, int qvH, 
				unsigned char *pImage, unsigned char *qvImage);
int __stdcall extract_zoom(int docType, int iMax, int jMax, int spp, int rowIn, int rowOut, int qvW, int qvH, 
				int iPosit, int jPosit, unsigned char *pImage, unsigned char *qvImage);
int __stdcall copie_mem(unsigned char *source, int taille, unsigned char *dest);

int __stdcall param2slider(float fparam, double invPower);
int __stdcall slider2param(int valClip, double valPower);

#ifdef __cplusplus
}
#endif
#endif
