#ifndef DETAILSENHANCERSETTINGS_H
#define DETAILSENHANCERSETTINGS_H


#include "processingsettingscontrol.h"

#include <gtkmm-3.0/gtkmm/box.h>
#include <gtkmm-3.0/gtkmm/checkbutton.h>
#include <gtkmm-3.0/gtkmm/grid.h>
#include <gtkmm-3.0/gtkmm/scale.h>
#include <sigc++/connection.h>


namespace PhotomatixControls
{
	class DetailsEnhancerSettings: public ProcessingSettingsControl
	{
	protected:
		sigc::connection effectsModeSignal;
		sigc::connection lightingAdjustmentsSignal;
		
		Gtk::Box* basicSettingsBox;
		Gtk::Widget* tabs;
		
		Gtk::Box* boxSlider;
		Gtk::Grid* boxButtons;
		Gtk::CheckButton* chkLightingEffectsMode;
		Gtk::CheckButton* chkLightingEffects;
		
		Gtk::ToggleButton* btnNaturalPlus;
		Gtk::ToggleButton* btnNatural;
		Gtk::ToggleButton* btnMedium;
		Gtk::ToggleButton* btnSurreal;
		Gtk::ToggleButton* btnSurrealPlus;
		
		std::vector <Gtk::ToggleButton*> buttons;

		Gtk::Scale* sldStrength;
		Gtk::Scale* sldSaturation;
		Gtk::Scale* sldLuminosity;
		Gtk::Scale* sldDetailContrast;
		Gtk::Scale* sldLightingAdjustments;
		Gtk::Scale* sldSmoothHighlights;
		Gtk::Scale* sldWhitePoint;
		Gtk::Scale* sldBlackPoint;
		Gtk::Scale* sldGamma;
		Gtk::Scale* sldTemperature;
		Gtk::Scale* sldMicroSmoothing;
		Gtk::Scale* sldSaturationHighlights;
		Gtk::Scale* sldSaturationShadows;
		Gtk::Scale* sldShadowsSmoothness;
		Gtk::Scale* sldShadowsClipping;
		
		Gtk::Label* lblStrength;
		Gtk::Label* lblSaturation;
		Gtk::Label* lblLuminosity;
		Gtk::Label* lblDetailContrast;
		Gtk::Label* lblLightingAdjustments;
		Gtk::Label* lblSmoothHighlights;
		Gtk::Label* lblWhitePoint;
		Gtk::Label* lblBlackPoint;
		Gtk::Label* lblGamma;
		Gtk::Label* lblTemperature;
		Gtk::Label* lblMicroSmoothing;
		Gtk::Label* lblSaturationHighlights;
		Gtk::Label* lblSaturationShadows;
		Gtk::Label* lblShadowsSmoothness;
		Gtk::Label* lblShadowsClipping;
		
		Gtk::CheckButton* chk360image;
		
		
		//@{
		/** Signal Handlers */
		void OnLightingEffectsModeToggled();
		void OnLightingEffectsToggled();
		void OnButtonClicked(Gtk::ToggleButton* btn);
		void OnSliderValueChanging(Gtk::Scale* sender);
		//@}
		
	public:
		DetailsEnhancerSettings(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& builder);
		virtual ~DetailsEnhancerSettings();
		
		PhotomatixImaging::XmpSettings GetSettings();
		void SetSettings(PhotomatixImaging::XmpSettings* settings);
	};
}
	
#endif // DETAILSENHANCERSETTINGS_H
