#ifndef DISPLAYABLEIMAGECONTROL_H
#define DISPLAYABLEIMAGECONTROL_H

#include <gtkmm/enums.h>
#include <gtkmm/container.h>
#include <gtkmm/image.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/drawingarea.h>
#include <memory>
#include "displayableimage.h"


namespace PhotomatixImaging
{
	class PhotoImage;
}

namespace PhotomatixControls
{
	class DisplayableImageControl : public Gtk::Box, public DisplayableImage
	{
	public:
		DisplayableImageControl();
		DisplayableImageControl(const std::string& fileName);
		virtual ~DisplayableImageControl();
		
		/** Creates new PhotoImage object by loading it from file. Then this image is displayed
		 * by the control.
		 */
		void Open(const std::string& fileName, bool openRAWs=false, int colorTemperature=0, int colorSpace=0);
		
		/// Method that allows showing existing PhotoImage object.
		void SetPhoto(std::shared_ptr <PhotomatixImaging::PhotoImage> photo);
		
		void SetZoomFactor(float zoomFactor, int maxWidth=0, int maxHeight=0);
	};
}

#endif //GTKMM_CUSTOM_CONTAINER_MYCONTAINER_H
