#ifndef PHOTOMATIX_EXCEPTIONS_H
#define PHOTOMATIX_EXCEPTIONS_H
#include <stdexcept>
namespace Photomatix
{
	class PhotomatixException : public std::exception
	{
	public:
		PhotomatixException(const std::string &message = "") : msg(message) { }
		virtual const char *what() const throw() { return msg.c_str(); }
		virtual ~PhotomatixException() throw() { }
	private:
		std::string msg;
	};

	class ResourceNotFoundException : public PhotomatixException
	{
	public:
		ResourceNotFoundException(const std::string message = "") : PhotomatixException(message) { }
	};

	class OutOfMemoryException: public PhotomatixException
	{
	public:
		OutOfMemoryException(const std::string message = "") : PhotomatixException(message) {}
	};

	class CantOpenImageException : public PhotomatixException
	{
	public:
		CantOpenImageException(const std::string message = "") : PhotomatixException(message) { }
	};
}
#endif
