#ifndef GLADEUTILS_H
#define GLADEUTILS_H
#include <gtkmm.h>
#include "ResourceUtils.h"
#include <iostream>

namespace PhotomatixUtils
{
	///
	/// Replacement for get_widget_derived that creates the builder,
	/// loads the Glade resource file, then calls the real get_widget_derived
	/// Assumes that the widget definition lives in a glade file with the
	/// same name.
	template <typename T_Widget> inline void get_widget_derived(const Glib::ustring& name, T_Widget*& widget)
	{
		Glib::RefPtr<Gtk::Builder> refBuilder = Gtk::Builder::create();
		try {
		refBuilder->add_from_file(GetGladeResourcePath(name).c_str());
		} catch (std::exception &e)
		{ std::cout << e.what() << std::endl; throw; }
		catch (Glib::Exception &e2)
		{ std::cout << e2.what() << std::endl; throw; }
		catch (...) { std::cout << "UNKNOWN EXCEPTION" << std::endl; throw; }

		refBuilder->get_widget_derived(name, widget);		
	}
}
#endif
